package com.huigou.topsun.sap.nonProdApply.application.impl;


import com.alibaba.fastjson.JSON;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.huigou.context.Operator;
import com.huigou.topsun.base.bsnMessage.appliction.BsnMessageApplication;
import com.huigou.topsun.base.bsnMessage.domain.*;
import com.huigou.topsun.base.bsnMessage.repository.BsnMessageSponsorRepository;
import com.huigou.topsun.sap.common.DefaultHttpClient;
import com.huigou.topsun.sap.common.application.SapMutualEpLogApplication;
import com.huigou.topsun.sap.nonProdApply.application.NonProdApplyDeptApplication;

import com.huigou.topsun.sap.nonProdApply.domain.NonProdApplyBaseInfo;
import com.huigou.topsun.sap.nonProdApply.domain.SapNonProdApplyDept;
import com.huigou.topsun.sap.nonProdApply.domain.vo.*;
import com.huigou.topsun.sap.nonProdApply.repository.NonProdApplyBaseInfoRepository;
import com.huigou.topsun.sap.nonProdApply.repository.NonProdApplyDeptRepository;
import com.huigou.uasp.bmp.common.application.BaseApplication;

import com.huigou.uasp.bmp.operator.OperatorApplication;
import com.huigou.util.ClassHelper;
import com.huigou.util.SDO;
import com.huigou.util.StringUtil;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.persistence.Column;
import java.util.*;

@Service
public class NonProdApplyDeptApplicationImpl extends BaseApplication implements NonProdApplyDeptApplication {

    @Autowired
    NonProdApplyDeptRepository nonProdApplyDeptRepository;
    @Autowired
    BsnMessageApplication bsnMessageApplication;
    @Autowired
    NonProdApplyBaseInfoRepository nonProdApplyBaseInfoRepository;

    @Autowired
    com.huigou.topsun.base.bsnMessage.repository.BsnMessageExecuteRepository bsnMessageExecuteRepository;
     @Autowired
    BsnMessageSponsorRepository bsnMessageSponsorRepository;
    @Autowired
    DefaultHttpClient defaultHttpClient;
    @Autowired
    SapMutualEpLogApplication sapMutualEpLogApplication;
    @Resource
    private OperatorApplication operatorApplication;


    @Override
    public Map<String,Object> saveSapNonProdApplyDept(SDO sdo){
        Map<String,Object> map = new HashMap<>();
        map.put("result","");
        String businessCode=sdo.getString("businessCode");
        String baseId=sdo.getString("id");
        String genericName=sdo.getString("genericName");
        Integer active=sdo.getInteger("active");
        String meId=sdo.getString("meId");
        String opstatus=sdo.getString("opstatus");  //操作状态
        NonProdApplyBaseInfo baseInfo=nonProdApplyBaseInfoRepository.findOne(sdo.getString("id"));
        //判断汉语品名是否已经存在
        if (StringUtil.isNotBlank(sdo.getString("maktx"))) {
            List<SapNonProdApplyDept> prodApplyDeptList = nonProdApplyDeptRepository.findByMaktx(sdo.getString("maktx").trim());
            if (prodApplyDeptList.size() > 0) {
                for (SapNonProdApplyDept prodApplyDept : prodApplyDeptList) {
                    NonProdApplyBaseInfo parentBaseInfo = nonProdApplyBaseInfoRepository.findOne(prodApplyDept.getBaseInfoId());
                    if (parentBaseInfo != null) {
                        if (baseInfo.getId().equals(parentBaseInfo.getId()) //表示是当前单据 忽略掉
                                || parentBaseInfo.getStatusId() == 5  //排除终止的
                        ) {
                        } else {
                            throw new RuntimeException("汉语品名:" + sdo.getString("maktx") + "已经存在！请检查输入");
                        }
                    }
                }
            }
        }

        baseInfo.setBusinessUsage(sdo.getString("businessUsage"));
        if (StringUtil.isNotBlank(sdo.getString("distribute"))){ //是否已分发
            baseInfo.setDistribute(2);
        } else {
            baseInfo.setDistribute(sdo.getInteger("active"));
        }
        if ("K".equals(businessCode)){  //首页进入的基本信息维护
            baseInfo.setGenericName(sdo.getString("genericName"));
            baseInfo.setApplicableStandard(sdo.getString("applicableStandard"));
            baseInfo.setBaseUnit(sdo.getString("baseUnit"));
            baseInfo.setSpecifications(sdo.getString("specifications"));
            baseInfo.setMaterial(sdo.getString("material"));
            baseInfo.setDesign(sdo.getString("design"));
            baseInfo.setSize(sdo.getString("size"));
         //   baseInfo.setGenericName(sdo.getString("brand"));

            baseInfo.setMaterialUsage(sdo.getString("materialUsage"));
            baseInfo.setItemAttributes(sdo.getString("itemAttributes"));
        }
        if ("V".equals(businessCode)) { //销售视图
            baseInfo.setBrand(sdo.getString("brand"));
            baseInfo.setBrand(sdo.getString("brandName"));
        }
        nonProdApplyBaseInfoRepository.save(baseInfo);

        NonProdApplyDeptVo deptVo=null;
        switch (businessCode) {
            case "K":
                deptVo = sdo.toObject(NonProdApplyBasicVo.class);
                break;
            case "C":
                deptVo = sdo.toObject(NonProdApplyClassVo.class);
                break;
            case "V":  //销售
                deptVo = sdo.toObject(NonProdApplySaleVo.class);
                break;
            case "E":
                deptVo = sdo.toObject(NonProdApplyPurchaseVo.class);
                break;
            case "D":
                deptVo = sdo.toObject(NonProdApplyMRPVo.class);
                break;
            case "A":
                deptVo = sdo.toObject(NonProdApplyProduceVo.class);
                break;
            case "L":
                deptVo = sdo.toObject(NonProdApplyStoreVo.class);
                break;
            case "S":
                deptVo = sdo.toObject(NonProdApplyWarehouseVo.class);
                break;
            case "Q":
                deptVo = sdo.toObject(NonProdApplyMassVo.class);
                break;
            case "B":
                deptVo = sdo.toObject(NonProdApplyFinancialVo.class);
                break;
            case "G":
                deptVo = sdo.toObject(NonProdApplyCostVo.class);
                break;
            default:
                deptVo = sdo.toObject(NonProdApplyBasicVo.class);
        }
       // SapNonProdApplyDept nonProdApplyDeptObj = sdo.toObject(SapNonProdApplyDept.class);
        //nonProdApplyDeptObj.setBaseInfoId(sdo.getId());
        deptVo.setBaseInfoId(sdo.getId());
        SapNonProdApplyDept nonProdApplyDept=nonProdApplyDeptRepository.findByBaseInfoId(sdo.getId());
        if (nonProdApplyDept==null){
            nonProdApplyDept=new SapNonProdApplyDept();
        }
        ClassHelper.copyProperties(deptVo,nonProdApplyDept);

        nonProdApplyDept = this.save(nonProdApplyDept);
        String applyDeptId=sdo.getString("applyDeptId");

        if ((StringUtil.isBlank(businessCode)||"INIT_DPT".equals(businessCode))&&"2".equals(sdo.getString("distribute"))) { //业务类型为空 ，表示是基本信息进入的  才保存分发信息
            //保存部门分发任务
            //获取分发的部门与人员信息
            ObjectMapper objectMapper = new ObjectMapper();
            String deptStaffJSON = sdo.getString("deptStaff");
            List<Map<String, String>> deptStaffList = null;
            try {
                deptStaffList = objectMapper.readValue(deptStaffJSON, new TypeReference<List<Map<String, String>>>() {
                });
                if (deptStaffList.size()<1){
                    throw new RuntimeException("未选择对应的分发人员！");
                }
            } catch (JsonProcessingException e) {
                throw new RuntimeException("JSON转换失败：" + e);
            }
            saveDeptStaff(deptStaffList, nonProdApplyDept.getApplyDeptId(),genericName);
        }
        if (active!=null&&active == 2&&opstatus.equals("1")){//各部门都提交后，隐藏消息
            bsnMessageApplication.submitTask(meId);
            //如果所有的业务部门处理完 ，则推送SAP
            BsnMessageSponsor bsnMessageSponsor=bsnMessageSponsorRepository.findByBusinessId(nonProdApplyDept.getApplyDeptId());
            boolean canSended=true;
            if (bsnMessageSponsor!=null){
                List<BsnMessageExecute> bsnMsgList = bsnMessageExecuteRepository.findAllByMessageSponsorId(bsnMessageSponsor.getId());
                for (BsnMessageExecute bsnMessageExecute : bsnMsgList) {
                    if (!"system".equals(bsnMessageExecute.getBusinessCode())&&
                        !"INIT_DPT".equals(bsnMessageExecute.getBusinessCode())
                       &&bsnMessageExecute.getActive() == 0) {
                        canSended=false;
                        break;
                    }
                }
            }
            if (canSended) {
              String backStr=sendSapData(baseInfo, nonProdApplyDept);
                map.put("result",backStr);
            }
        }

        map.put("applyDeptId",nonProdApplyDept.getApplyDeptId());
        return map;
    }

    @Override
    public SapNonProdApplyDept save(SapNonProdApplyDept sapNonProdApplyDept){
        return nonProdApplyDeptRepository.save(sapNonProdApplyDept);
    }
    @Override
    public void saveDeptStaff(List<Map<String, String>> deptStaffList,String bussinessId,String genericName){
        //封装分发数据
        BsnMessageSponsor bsnMessageSponsor = new BsnMessageSponsor();
        bsnMessageSponsor.setTaskSponsor(this.getOperator().getUserId());
        bsnMessageSponsor.setTitle(genericName);//通用品名
        bsnMessageSponsor.setExecutorUrl("sapNonProdApplyNext/fillInNonProdApplyDept.do");
        bsnMessageSponsor.setBusinessId(bussinessId);
        bsnMessageSponsor.setCreateDate(new Date());
        bsnMessageSponsor.setStatus(0);

        for (Map<String, String> stringMap : deptStaffList) {
            BsnMessageExecute messageExecute = new BsnMessageExecute();
            String userCode = stringMap.get("userCode");
            String deptName = stringMap.get("deptName");
            String deptCode = stringMap.get("deptCode");
            String[] split = userCode.split("@");
            messageExecute.setTaskExecute(split[0]);
            messageExecute.setBusinessCode(deptCode);
            messageExecute.setActive(ActiveStatus.UNFINISHED.getValue());
            messageExecute.setUpdateDate(new Date());
            messageExecute.setTaskDescribe(deptName+"部门数据维护");
            bsnMessageSponsor.addExecute(messageExecute);
        }
        //保存任务
        bsnMessageApplication.keepTasks(bsnMessageSponsor);

    }
    /**
     * 发布任务
     * @param sdo
     */
    @Override
    public void distributeSapNonProdApplyDept(SDO sdo) {
        //获取分发的部门与人员信息
        ObjectMapper objectMapper = new ObjectMapper();
        String deptStaffJSON = sdo.getString("deptStaff");
        List<Map<String, String>> deptStaffList = null;
        try {
            deptStaffList = objectMapper.readValue(deptStaffJSON, new TypeReference<List<Map<String, String>>>() {});
            if (deptStaffList.size()<1){
                throw new RuntimeException("未选择对应的分发人员！");
            }
        } catch (JsonProcessingException e) {
            throw new RuntimeException("JSON转换失败："+e);
        }
        //将状态为保存未分发的全部修改为分发未完成
        Map<String, Object> map = this.saveSapNonProdApplyDept(sdo);

        //结束分发任务的待办信息
        NonProdApplyBaseInfo nonProdApplyBaseInfo=nonProdApplyBaseInfoRepository.findOne(sdo.getString("id"));

        if(nonProdApplyBaseInfo.getMaintenanceType().equals("new")) { //新申请的 分发后结束分发人的待办信息 06.17
            BsnMessageSponsor bsnMessageSponsor=bsnMessageSponsorRepository.findByBusinessId(nonProdApplyBaseInfo.getId());
            if (bsnMessageSponsor!=null){
                List<BsnMessageExecute> bsnMsgList = bsnMessageExecuteRepository.findAllByMessageSponsorId(bsnMessageSponsor.getId());
                for (BsnMessageExecute bsnMessageExecute : bsnMsgList) { //目前指定到岗位 货源专员 HYZY
                    if ("HYZY".equals(bsnMessageExecute.getBusinessCode())) {
                        bsnMessageApplication.submitTask(bsnMessageExecute.getId());
                    }
                }
            }

        }
         //发布各业务人员待处理的任务
        bsnMessageApplication.publishTasks((String) map.get("applyDeptId"));


    }

    @Override
    public SapNonProdApplyDept getNonProdApplyDeptById(String id) {
        return nonProdApplyDeptRepository.findByApplyDeptId(id);
    }

    @Override
    public SapNonProdApplyDept getNonProdApplyDeptByBaseInfoId(String baseInfoId) {
        return nonProdApplyDeptRepository.findByBaseInfoId(baseInfoId);
    }
    @Override
    public SapNonProdApplyDept getNonProdApplyDeptByMatnr(String matnr){
        return nonProdApplyDeptRepository.findByMatnr(matnr);
    }
    @Override
    public void deleteSapNonProdApplyDept(SapNonProdApplyDept sapNonProdApplyDept){
        if (sapNonProdApplyDept!=null){
            nonProdApplyDeptRepository.delete(sapNonProdApplyDept);
        }
    }

    @Override
    public void rejectNonProdApplyDept(SDO sdo) {
        String meId = sdo.getString("meId");
        Map<String,Object> map = new HashMap<>();
        String auditDept = sdo.getString("auditDept");
        List<String> deptList = Arrays.asList(auditDept.split(","));
        for (String key : deptList) {
            map.put(key,sdo.getString(key));
        }
        bsnMessageApplication.rejectTasksByMeId(map,meId);
    }

    /**
     * 远程调用sap接口，传递数据
     */
    public String sendSapData(NonProdApplyBaseInfo baseInfo,SapNonProdApplyDept applyDept) {
        Map<String, Object> map = new HashMap<>();
        String backStr="";
        ProdApplyToSapVO sapVO=new ProdApplyToSapVO();
        ClassHelper.copyProperties(baseInfo,sapVO);
        ClassHelper.copyProperties(applyDept,sapVO);

        if ("0".equals(sapVO.getXchpf())){ //批次管理 否 传递空
            sapVO.setXchpf("");
        }
        sapVO.setPstat(baseInfo.getBusinessUsage());
        sapVO.setUpdkz("I");
        if ("0".equals(sapVO.getInsmk())){
            sapVO.setInsmk("");
        }
        if ("0".equals(sapVO.getRgekz())){
            sapVO.setRgekz("");
        }
        //存储分区标识默认001
        sapVO.setLgbkz("001");
         sapVO.setMbrsh("M");//行业默认M
        if ("0".equals(sapVO.getPerkz())){ //期间标识
           sapVO.setPerkz("");
        }
        //销售单位转换
        if (StringUtil.isNotBlank(sapVO.getVrkme())){
            Map<String,Object> unitsaleMap = new HashMap<>();
            List<Map<String,Object>> unitMapList = new ArrayList<>();
            unitsaleMap.put("MEINH",sapVO.getVrkme());
            unitsaleMap.put("UMREZ",sapVO.getUmrez());
            unitsaleMap.put("UMREN",sapVO.getUmren()); //去掉sale   lxh  03.29
            unitsaleMap.put("MEINS",sapVO.getMeins());
            unitMapList.add(unitsaleMap);
            sapVO.setMapList(unitMapList);
        }
        ObjectMapper objectMapper = new ObjectMapper();
        String url = "bd_mastdata/material";
        String busiType="物料主数据推送SAP";
        if ("product".equals(baseInfo.getKind())){
            url = "bd_mastdata/material02";
            busiType="产品主数据推送SAP";
        }
        List<ProdApplyToSapVO> mapList = new ArrayList<>();
        mapList.add(sapVO);
        //日志记录

        Map<String, Object> backMap = new HashMap<>();
        backMap.put("businessType", busiType);
        backMap.put("businessId", baseInfo.getId());
        backMap.put("parameter", JSON.toJSONString(mapList));
        backMap.put("sequence", backMap.get("row"));
        backMap.put("TYPE", "E");
        try {
            String result = defaultHttpClient.execute(mapList, url);
            List<Map<String, Object>> resultList = objectMapper.readValue(result, new TypeReference<List<Map<String, Object>>>() {
            });
            Map<String, Object>  returnMap = resultList.get(0);
            if ("2".equals(returnMap.get("TYPE"))){
                returnMap = resultList.get(1);
            }
            mapCopy(backMap,returnMap);
            // resultMap.put("businessType", busiType);
            // resultMap.put("parameter", JSON.toJSONString(map));
            //  resultMap.put("businessId", prodApplyBaseInfo.getId());
            if ("S".equals(returnMap.get("TYPE"))) {
                backMap.put("TYPE", "S");
                backMap.put("MESSAGE",applyDept.getMatnr()+":"+backMap.get("MESSAGE"));
                if (!"product".equals(baseInfo.getKind())) {
                    applyDept.setMatnr((String) backMap.get("MESSAGE_V1"));
                }
                this.nonProdApplyDeptRepository.save(applyDept);
                baseInfo.setDistribute(3); //已办结
                nonProdApplyBaseInfoRepository.save(baseInfo);
            } else {
                //更改分发状态
                baseInfo.setDistribute(1);
                backStr="传输失败:" + backMap.get("MESSAGE");
                backMap.put("MESSAGE",backStr);
                nonProdApplyBaseInfoRepository.save(baseInfo);
                //throw new RuntimeException(backStr);
            }
        } catch (Exception e) {
            backMap.put("MESSAGE",applyDept.getMatnr()+":"+e.getMessage());
            //sapMutualEpLogApplication.saveSapMutualEpLog(resultMap);
            System.out.println("传输错误了："+e.getMessage());
            backStr="传输失败:" +  e.getMessage();
            throw new RuntimeException(backStr);
        } finally {
            sapMutualEpLogApplication.saveSapMutualEpLog(backMap);
            Operator operator = operatorApplication.createOperatorByPersonMemberId(baseInfo.getPersonMemberId());
            saveBsnMessageData(baseInfo,applyDept,operator,backMap);
            return backStr;
        }

    }

    final void mapCopy(Map resultMap, Map paramMap) {
        if (resultMap==null) resultMap=new HashMap();
         if (paramMap==null ) return ;

         Iterator it=paramMap.entrySet().iterator();
        while (it.hasNext()){
           Map.Entry entry=(Map.Entry)it.next();
           Object key=entry.getKey();
           resultMap.put(key,paramMap.get(key)!=null?paramMap.get(key):"");
        }
    }


    //保存待办的消息
    public void saveBsnMessageData(NonProdApplyBaseInfo baseInfo, SapNonProdApplyDept applyDept, Operator operator,Map<String,Object> map) {
        BsnMessageSponsor  bsnMessageSponsor=bsnMessageSponsorRepository.findByBusinessId(applyDept.getApplyDeptId());
        if (bsnMessageSponsor==null) {
            bsnMessageSponsor = new BsnMessageSponsor();
            bsnMessageSponsor.setTaskSponsor(operator.getLoginUser().getId());
            bsnMessageSponsor.setTitle(baseInfo.getGenericName());//通用品名
            bsnMessageSponsor.setExecutorUrl("sapNonProdApplyNext/forwardNonProdApplyNext.do?prod=1&isReadOnly=false");
            bsnMessageSponsor.setBusinessId(applyDept.getApplyDeptId());
            bsnMessageSponsor.setCreateDate(new Date());
            bsnMessageSponsor.setStatus(0);
        }
        //List<Map<String, String>> deptStaffList=new ArrayList<>();
        //Map <String,String>map=new HashMap<String, String>();
        // map.put("");
        //deptStaffList.add(map);
        // for (Map<String, String> stringMap : deptStaffList) {
        BsnMessageExecute messageExecute = new BsnMessageExecute();
        String userCode = operator.getPersonMemberId();//stringMap.get("userCode");
        String deptName = operator.getDeptName();//stringMap.get("deptName");
        String deptCode = operator.getDeptCode();//stringMap.get("deptCode");
        String[] split = userCode.split("@");
        messageExecute.setTaskExecute(split[0]);
        messageExecute.setBusinessCode(deptCode);
        messageExecute.setActive(ActiveStatus.UNFINISHED.getValue());
        messageExecute.setUpdateDate(new Date());
       // if ("product".equals(baseInfo.getKind())) {
       //     messageExecute.setTaskDescribe(deptName + "产品数据维护");
       // } else {
         if ("S".equals(map.get("TYPE").toString())){
            messageExecute.setTaskDescribe("成功"+map.get("MESSAGE").toString());
         } else {
            messageExecute.setTaskDescribe("错误"+map.get("MESSAGE").toString());
          }
        bsnMessageApplication.saveBsnMessageSponsor(bsnMessageSponsor);
        messageExecute.setMessageSponsorId(bsnMessageSponsor.getId());

        List<BsnMessageExecute> executes = new ArrayList<>();
        executes.add(messageExecute);
        bsnMessageApplication.saveBsnMessageExecute(executes);
    }
}
